/********************************************************************************
 Author : 

 Date :   August 1, 2014

 File name :  ad7989test.c

 Description :	 Serve as example on how to use AD7989-1 and AD7989-5.c

 Hardware plateform : 	AD7989 & ADuCM360
********************************************************************************/

#include <ADuCM360.h>
#include <stdio.h>
#include <string.h>

#include "..\common\UrtLib.h"
#include "..\common\ClkLib.h"
#include "..\common\WdtLib.h"
#include "..\common\IntLib.h"
#include "..\common\DioLib.h"
#include "..\common\SpiLib.h"
#include "..\common\UrtLib.h"

#include "AD7989.h"
#include "ADUCm360driver.h"

int Data;

void SendString (void);
void SendResultToUART(void);

// UART-based external variables
unsigned char ucTxBufferEmpty  = 0;				       // Used to indicate that the UART Tx buffer is empty
unsigned char szData[64] = "";					         // Used to store string before printing to UART
unsigned char nLen = 0;
unsigned char i = 0;
unsigned char ucWaitForUart = 0;				         // Used by calibration routines to wait for user input
volatile unsigned char bSendResultToUART = 0;

int main (void)
{

   WdtCfg(T3CON_PRE_DIV1,T3CON_IRQ_EN,T3CON_PD_DIS);      										//Disable Watchdog timer resets
                                                                              //Disable clock to unused peripherals
   ClkDis(CLKDIS_DISI2CCLK|CLKDIS_DISPWMCLK|CLKDIS_DIST0CLK|CLKDIS_DIST1CLK); //Only enable clock to used blocks
   ClkCfg(CLK_CD0,CLK_HF,CLKSYSDIV_DIV2EN_DIS,CLK_UCLKCG);										// Select CD0 for CPU clock with 16MHz UCLK (div2 enabled on oscillator output)
   ClkSel(CLK_CD0,CLK_CD7,CLK_CD0,CLK_CD7);               										// Select CD0 for UART,SPI System clock
		
	 AD7989INIT();
	 UARTINIT();
	
	 NVIC_EnableIRQ(UART_IRQn);
	 	
   while (1)
   { 
		 ///******CS Mode Example********************************************************
		 	Data = CSmode_3Wire();
		  bSendResultToUART = 0;
			SendResultToUART();
		 //********************************************************************************/
	 }
	
}

void SendString (void)
{
   for ( i = 0 ; i < nLen ; i++ )
	{
  		 ucTxBufferEmpty = 0;
		   UrtTx(pADI_UART,szData[i]);
  		 while (ucTxBufferEmpty == 0)
  		 {
  		 }
	}
} 

void SendResultToUART(void)
{
	sprintf ( (char*)szData, "ADC1 Data: %X \r\n", Data );                          
	nLen = strlen((char*)szData);
	if (nLen <64)
 		SendString();
}


void UART_Int_Handler ()
{
   volatile unsigned char ucCOMSTA0 = 0;
   volatile unsigned char ucCOMIID0 = 0;

   ucCOMIID0 = UrtIntSta(pADI_UART);   // Read UART Interrupt ID register
   if ((ucCOMIID0 & 0x2) == 0x2)       // Transmit buffer empty
   {
      ucTxBufferEmpty = 1;
   }
   if ((ucCOMIID0 & 0x4) == 0x4)       // Receive byte
   {
      ucWaitForUart = 0;
   }
}
