/********************************************************************************
 Author :

 Date :	September 2, 2014

 File name :   ADUCM360driver.c

 Description :	 To initiate the different functionalities of ADuCM360.

 Hardware plateform : 	ADuCM360
********************************************************************************/

#include <ADuCM360.h>
#include "..\common\DioLib.h"
#include "..\common\SpiLib.h"
#include "..\common\UrtLib.h"
#include "ADUCm360driver.h"
#include "AD7989.h"

//Initiate SPI0
void SPI0INIT (void)
{
	DioCfgPin(pADI_GP1,PIN4,2);                           // Configure P1.4 as MISO
	DioCfgPin(pADI_GP1,PIN5,2);                           // Configure P1.5 as SCLK 
	DioCfgPin(pADI_GP1,PIN6,2);                           // Configure P1.6 as MOSI
	DioCfgPin(pADI_GP1,PIN7,2);                           // Configure P1.7 as \CS	
	
   SpiBaud(pADI_SPI0,0x07,SPIDIV_BCRST_DIS);             //Set the SPI clock rate in Master mode to 4MHz
   SpiCfg(pADI_SPI0,SPICON_MOD_TX1RX1,SPICON_MASEN_EN,
        SPICON_CON_EN|SPICON_TIM_TXWR|SPICON_ENABLE_EN|SPICON_CPHA_SAMPLETRAILING);  //Enable SPI0 Master mode
}

void UARTINIT (void)
{
   	//Select IO pins for UART.
		pADI_GP0->GPCON |= 0x3C;					           		// Configure P0.1/P0.2 for UART		
	  //pADI_GP0->GPCON |= 0x9000; 					          // Configure P0.6/P0.7 for UART
    UrtCfg(pADI_UART,B9600,COMLCR_WLS_8BITS,0);  	  // setup baud rate for 9600, 8-bits
    UrtMod(pADI_UART,COMMCR_DTR,0);  			       		// Setup modem bits
    UrtIntCfg(pADI_UART,COMIEN_ERBFI|COMIEN_ETBEI|COMIEN_ELSI|COMIEN_EDSSI|COMIEN_EDMAT|COMIEN_EDMAR);  // Setup UART IRQ sources
}

void AD7989INIT(void)
{
	DioCfgPin(pADI_GP1,PIN0,0);
	DioCfgPin(pADI_GP1,PIN2,0);
	DioCfgPin(pADI_GP1,PIN3,0);
		
	DioOenPin(pADI_GP0,PIN0,0);					// Config P0.0 as IRQ3
	DioOenPin(pADI_GP1,PIN2,1);					// Config P1.2 as SDI/CS
	DioOenPin(pADI_GP1,PIN3,1);					// Config P1.3 as CS
	
	DioSet (pADI_GP1, SDI|CNV);					// Config P1.2 to CLR SDI = 0
																			// Config P1.3 to CLR CNV = 0
	SPI0INIT();
}
